/*
"(c) Copyright 1993-1997 Pad++ Consortium {University of New Mexico (UNM),
and New York University (NYU)}, All Rights Reserved."  
Licensee can not remove or obscure any of the
copyright or trademark notices in this software.

IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
MODIFICATIONS.

See the file "License" for general information on usage and
redistribution, and the file "LicenseTerms" for the specific license
agreement on usage and redistribution of this file, and the Pad++
software in general.
*/

#ifndef BIND_H
#define BIND_H 1

#include "defs.h"
#include "events.h"
#include <X11/keysym.h>         // needed for KeySym declaration

class Pad_Object;
class Pad_Callback;

//
// Declare function prototypes
//
void     Pad_AddBindingModifier(char *modifier);
void     Pad_BindEvent(Tk_BindingTable bindingTable, XEvent *eventPtr, Pad_Event *padEvent,
		       int numObjects, ClientData *objectPtr, Pad_Object *itemPtr);
Tk_BindingTable Pad_CreateBindingTable(Tcl_Interp *interp);
unsigned long Pad_CreateBinding(Tcl_Interp *interp, Tk_BindingTable bindingTable, ClientData object, 
				char *eventString, char *command, int append);
unsigned long Pad_CreateBinding(Tcl_Interp *interp, Tk_BindingTable bindingTable, ClientData object, 
				char *eventString, Pad_Callback *callback);
void     Pad_DeleteAllBindings(Tk_BindingTable bindingTable, ClientData object);
int      Pad_DeleteBinding(Tcl_Interp *interp, Tk_BindingTable bindingTable, ClientData object, 
			   char *eventString);
Pad_Bool Pad_DeleteBindingModifier(char *modifier);
void     Pad_DeleteBindingTable(Tk_BindingTable bindingTable);
char *   Pad_GetBinding(Tcl_Interp *interp, Tk_BindingTable bindingTable, ClientData object, char *eventString);
void     Pad_GetAllBindings(Tcl_Interp *interp, Tk_BindingTable bindingTable, ClientData object);
int      Pad_GetBindingModifier(char *modifier);
char *   Pad_GetBindingModifier(int mode);
char *   Pad_GetEventName(int type);
void     Pad_Expand_event_macros(char input,Tcl_DString *dsPtr,Pad_Event *padEvent,KeySym keySym);

#endif
