/*
"(c) Copyright 1993-1997 Pad++ Consortium {University of New Mexico (UNM),
and New York University (NYU)}, All Rights Reserved."  
Licensee can not remove or obscure any of the
copyright or trademark notices in this software.

IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
MODIFICATIONS.

See the file "License" for general information on usage and
redistribution, and the file "LicenseTerms" for the specific license
agreement on usage and redistribution of this file, and the Pad++
software in general.
*/

#ifndef HLIST_H
#define HLIST_H 1

#include "list.h"

class Pad_Handle;

//
// A Pad_HandleList is a list of Pad_Handle's.
// It derives from Pad_List, and is like a Pad_List in every way except that
// when the Pad_HandleList is destroyed, the handles on the list are destroyed
// with the list.  This unlike a regular list where the objects on the list are
// left alone when the list is destroyed.
//
class Pad_HandleList : public Pad_List
{
  public:
    virtual int         Insert_before(Pad_Handle *handle, Pad_Handle *ref);
    virtual int         Insert_after(Pad_Handle *handle, Pad_Handle *ref);
    virtual void        Make_empty(void);
    virtual void        Push(Pad_Handle *handle);
    virtual void        Push_last(Pad_Handle *handle);
    virtual int         Push_new(Pad_Handle *handle);
    virtual int         Push_new_last(Pad_Handle *handle);
    virtual int         Remove(Pad_Handle *handle);

    Pad_HandleList();
    Pad_HandleList(Pad_HandleList &hlist);
    virtual ~Pad_HandleList();
};

#endif
