/*
"(c) Copyright 1993-1997 Pad++ Consortium {University of New Mexico (UNM),
and New York University (NYU)}, All Rights Reserved."  
Licensee can not remove or obscure any of the
copyright or trademark notices in this software.

IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
MODIFICATIONS.

See the file "License" for general information on usage and
redistribution, and the file "LicenseTerms" for the specific license
agreement on usage and redistribution of this file, and the Pad++
software in general.
*/

#include "init.h"
#include "line-font.h"
#include "global.h"
#include "animatable.h"

#ifdef HAS_SOUND
#include "pad-tcl-sound.h"
#include "pad-sound.h"
#endif /* HAS_SOUND */

class Pad_Animatable;

void 
Pad_MasterInit(void)
{
    static Pad_Bool init = FALSE;

    if (init == TRUE) {
	return;
    }
    init = TRUE;

    Pad_allUid =       Tk_GetUid("all");
    Pad_noneUid =      Tk_GetUid("none");
    Pad_currentUid =   Tk_GetUid("current");

    Pad_aliasUid =     Tk_GetUid("alias");
    Pad_buttonUid =    Tk_GetUid("button");
    Pad_checkboxUid =  Tk_GetUid("checkbox");
    Pad_menuitemUid =  Tk_GetUid("menuitem");
    Pad_checkboxmenuitemUid =  Tk_GetUid("checkboxmenuitem");
    Pad_menuUid =      Tk_GetUid("menu");
    Pad_menubarUid =   Tk_GetUid("menubar");
    Pad_choicemenuUid =Tk_GetUid("choicemenu");
    Pad_canvasUid =    Tk_GetUid("canvas");
    Pad_containerUid = Tk_GetUid("container");
    Pad_frameUid =     Tk_GetUid("frame");
    Pad_gridUid =      Tk_GetUid("grid");
    Pad_groupUid =     Tk_GetUid("group");
    Pad_htmlUid =      Tk_GetUid("html");
    Pad_htmlAnchorUid =Tk_GetUid("htmlanchor");
    Pad_imageUid =     Tk_GetUid("image");
    Pad_kplUid =       Tk_GetUid("kpl");
    Pad_labelUid =     Tk_GetUid("label");
    Pad_lineUid =      Tk_GetUid("line");
    Pad_splineUid =    Tk_GetUid("spline");
    Pad_padUid =       Tk_GetUid("pad");
    Pad_panelUid =     Tk_GetUid("panel");
    Pad_ovalUid =      Tk_GetUid("oval");
    Pad_polygonUid =   Tk_GetUid("polygon");
    Pad_portalUid =    Tk_GetUid("portal");
    Pad_rectangleUid = Tk_GetUid("rectangle");
    Pad_scrollbarUid = Tk_GetUid("scrollbar");
    Pad_tclUid =       Tk_GetUid("tcl");
    Pad_textUid =      Tk_GetUid("text");
    Pad_textfileUid =  Tk_GetUid("textfile");
    Pad_textfieldUid = Tk_GetUid("textfield");
    Pad_textareaUid =  Tk_GetUid("textarea");
    Pad_windowUid =    Tk_GetUid("window");

    Pad_LineFont::InitLineFonts();
#ifdef HAS_SOUND
    Padtcl_sound_init();
    Pad_Sound::Init();
#endif /* HAS_SOUND */
}




