/*
"(c) Copyright 1993-1997 Pad++ Consortium {University of New Mexico (UNM),
and New York University (NYU)}, All Rights Reserved."  
Licensee can not remove or obscure any of the
copyright or trademark notices in this software.

IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
MODIFICATIONS.

See the file "License" for general information on usage and
redistribution, and the file "LicenseTerms" for the specific license
agreement on usage and redistribution of this file, and the Pad++
software in general.
*/

#ifndef TKWIN_H
#define TKWIN_H 1

#include "defs.h"
#include "win.h"

//
// Function prototypes
//
extern "C" int  Pad_Init(Tcl_Interp *interp);
int      Pad_Configure_widget(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]);
Pad_Bool Pad_Create_win(Tcl_Interp *interp, char *padName);

class Pad_TkWin : public Pad_Win
{
  public:
    virtual void      Configure(int newWidth, int newHeight);  // Window's configuration has changed
            Tk_Window Get_tkwindow(void);                      // Returns Tk_Window pointer (if one exists)
    virtual Window Get_toplevel_window_id();                   // Returns XID of toplevel window frame 
    virtual void      Map(void);                               // Window has appeared on screen
            void      Set_tkwindow(Tk_Window tkwindow);        // Sets Tk_Window pointer

    Pad_TkWin(Tcl_Interp *interp, Tk_Window tkwin);
    virtual ~Pad_TkWin();

  private:
    Tk_Window     _tkwin;	// The Tk window structure containing our window
};

#endif
