// ************************************************************************
// XDR utilities declaration
//
// Declares utilities for XDR encoding and decoding.
//
// ************************************************************************


#ifndef XDRUTIL_H
#define XDRUTIL_H

extern "C" {

  int XDREncodeStringC(const char* input, unsigned char* output,
    unsigned int length);
  int XDREncodeShortArray(const short* input, unsigned int inputLength,
    unsigned char* output, unsigned int outputLength);
  int XDREncodeIntArray(const int* input, unsigned int inputLength,
    unsigned char* output, unsigned int outputLength);
  int XDREncodeLongArray(const long* input, unsigned int inputLength,
    unsigned char* output, unsigned int outputLength);
  int XDREncodeUCharArray(const unsigned char* input,
    unsigned int inputLength, unsigned char* output,
    unsigned int outputLength);
  int XDREncodeUShortArray(const unsigned short* input,
    unsigned int inputLength, unsigned char* output,
    unsigned int outputLength);
  int XDREncodeUIntArray(const unsigned int* input, unsigned int inputLength,
    unsigned char* output, unsigned int outputLength);
  int XDREncodeULongArray(const unsigned long* input, unsigned int inputLength,
    unsigned char* output, unsigned int outputLength);
  int XDREncodeFloatArray(const float* input, unsigned int inputLength,
    unsigned char* output, unsigned int outputLength);
  int XDREncodeDoubleArray(const double* input, unsigned int inputLength,
    unsigned char* output, unsigned int outputLength);

  int XDRDecodeStringC(const unsigned char* input, unsigned int inputLength,
    char* output, unsigned int outputLength);
  int XDRDecodeShortArray(const unsigned char* input, unsigned int inputLength,
    short* output, unsigned int outputLength);
  int XDRDecodeIntArray(const unsigned char* input, unsigned int inputLength,
    int* output, unsigned int outputLength);
  int XDRDecodeLongArray(const unsigned char* input, unsigned int inputLength,
    long* output, unsigned int outputLength);
  int XDRDecodeUCharArray(const unsigned char* input,
    unsigned int inputLength, unsigned char* output,
    unsigned int outputLength);
  int XDRDecodeUShortArray(const unsigned char* input,
    unsigned int inputLength, unsigned short* output,
    unsigned int outputLength);
  int XDRDecodeUIntArray(const unsigned char* input, unsigned int inputLength,
    unsigned int* output, unsigned int outputLength);
  int XDRDecodeULongArray(const unsigned char* input, unsigned int inputLength,
    unsigned long* output, unsigned int outputLength);
  int XDRDecodeFloatArray(const unsigned char* input, unsigned int inputLength,
    float* output, unsigned int outputLength);
  int XDRDecodeDoubleArray(const unsigned char* input,
    unsigned int inputLength, double* output, unsigned int outputLength);

}

#endif




