#ifndef NCD_SOUND_H
#define NCD_SOUND_H
/*
"(c) Copyright 1993-1997 Pad++ Consortium {University of New Mexico (UNM),
and New York University (NYU)}, All Rights Reserved."  
Licensee can not remove or obscure any of the
copyright or trademark notices in this software.

IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
MODIFICATIONS.

See the file "License" for general information on usage and
redistribution, and the file "LicenseTerms" for the specific license
agreement on usage and redistribution of this file, and the Pad++
software in general.
*/
#include <stdio.h>
#include <tcl.h>
#undef BYTE
#include <audio/audiolib.h>
#include "../generic/pad-sound.h"
#include "../generic/defs.h"
#include "../generic/api.h"

class NCDSoundDevice;
class Pad_String;
class Pad_NCDSound;

struct Volume_struct {
    int right;
    int left;
};

struct Play_struct {
    long *buf;
    Pad_AudioFormat *format;
    long nsamp;
    Pad_Bool loop;
    Pad_Bool vol;
};

////////////////////////////////////////////////////////////////
//
// NCDSoundDevice subclass of SoundDevie
//
//
////////////////////////////////////////////////////////////////

class NCDSoundDevice : public SoundDevice{
public:
    NCDSoundDevice();
    virtual ~NCDSoundDevice();
  
    virtual int Play(Pad_SoundConfig *config, Pad_PlayState *state);
    virtual Pad_Bool Load(Pad_Sound &sound);
    virtual int Stop(void);
    virtual int Set_volume(int &master);
    virtual int Set_volume(int &left, int &right);
    virtual int Get_volume(int &left, int &right) const;
    virtual AuBucketID Bucket_from_data(Pad_Sound &sound);
    virtual void Free_sound(Pad_Sound &sound);
protected:
    Pad_String *_deviceName;
    AuServer   *_audio;
    AuDeviceID  _device;
};


////////////////////////////////////////////////////////////////
//
// NCDAudioFormat subclass of Pad_AudioFormat
//
//
////////////////////////////////////////////////////////////////

class NCDAudioFormat : public Pad_AudioFormat {
public:
    NCDAudioFormat();
    virtual ~NCDAudioFormat();
  
        ////////////////////////////////////////
        //
        // Utility functions
        //
        ////////////////////////////////////////

    virtual long            Read(void);
            AuBucketID      Get_bucket(void) const;
            Pad_Bool        Set_bucket(AuBucketID bucket);
    virtual AuFlowID        Get_flow(void);
    virtual void            Set_flow(AuFlowID flow);
protected:
    AuBucketID       _bucket;
    AuFlowID         _flow;
};

#endif /* NCD_SOUND_H */
