/*
"(c) Copyright 1993-1997 Pad++ Consortium {University of New Mexico (UNM),
and New York University (NYU)}, All Rights Reserved."  
Licensee can not remove or obscure any of the
copyright or trademark notices in this software.

IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
MODIFICATIONS.

See the file "License" for general information on usage and
redistribution, and the file "LicenseTerms" for the specific license
agreement on usage and redistribution of this file, and the Pad++
software in general.
*/
#ifndef SGI_SOUND_H
#define SGI_SOUND_H

#include <dmedia/audio.h>
#include <dmedia/audiofile.h>
#include "../generic/pad-sound.h"

class SgiAudioFormat;

class SgiSoundDevice : public SoundDevice{
public:
  SgiSoundDevice();
  virtual ~SgiSoundDevice();

          int Play(Pad_SoundConfig*, Pad_PlayState*);
  virtual int Stop(void);
  virtual int Set_volume(int &master);
  virtual int Set_volume(int &left, int &right);
  virtual int Reset_volume(int &left, int &right);
  virtual int Get_volume(int &left, int &right) const;
  virtual Pad_Bool Load(Pad_Sound &sound);
          Pad_AudioFormat *New_format(void);
protected:
  ALconfig _audioConfig;
  ALport   _audioPort;
  Pad_String * _deviceName;
  char * _audioBuffer;
  int    _bufferCount;
  
  int  _Get_output_rate(void);
  int  _Init_play(Pad_AudioFormat *format);
  void _Play(Pad_AudioFormat *format, char *buf,long nsamp);
  void _Stop_play(void);
  void _Flush(void);
};

////////////////////////////////////////////////////////////////
//
// SgiAudioFormat Class
//
//
////////////////////////////////////////////////////////////////

class SgiAudioFormat : public Pad_AudioFormat {
public:
  SgiAudioFormat();
  SgiAudioFormat(AFfilehandle, const char*);
  ~SgiAudioFormat();
  
          Pad_Bool Open_format(char *);
  virtual long     Read(void);
  virtual Pad_SoundFormat Get_style(void) const;
  virtual long     Get_rate(void) const;
  virtual long     Get_channels(void) const;
  virtual long     Get_bits_per_sample(void) const;
  virtual long     Get_length(void) const;
  virtual void *   Get_private(void) const;
  virtual char *   Get_data(void) const;
private:
  long _bitsPerSample;
  long _sampType;
  long _rate;
  long _channels;
  AFfilehandle _fileHandle;
};


#endif /* SGI_SOUND_H */
